<?php
class googleChart
{
    /**
     * Google bar options
     *
     * 'chs' - chart size in pixels
     * 'chd' - chart data encoded properly (in this case no encoding, plain text - t)
     * 'chds - A set of one or more minimum and maximum allowable values for each data series, separated by commas.
     * 'cht' - chart type(default vertical bars staked)
     * 'chl' - chart labels
     * 'chco'- chart bars(or lines, pies etc.) colors
     * 'chf' - cahrt solid fill(background) - <fill type>,s,<color>|<fill type>,ls(or lg),<angle>,<color 1>,<width 1>
     * 			'bg' for background fill, 'c' for chart area fill, 'a' to apply transparency to the whole chart.
     * 			's' indicates solid fill, 'lg' specifies linear gradient, 'ls' specifies linear stripes
     *			<color> is an RRGGBB format hexadecimal number.
     * 			<angle> specifies the angle of the gradient or stripes between 0 (horizontal) and 90 (vertical).
     *			the pipe character (|) separates fill definitions. No pipe character is required after the second definition.
     * 'chtt' - <chart title> Specify a space with a plus sign (+).Use a pipe character (|) to force a line break.
     * 'chts' - Optionally, you can also set the title's color and size with <color>,<font size>
     * 'chxt' - Specify multiple axes - x = bottom x-axis, t = top x-axis, y = left y-axis, r = right y-axis
     * 'chxl' - Specify labels with - <axis index>:|<label 1>|<label n>| - The index parameter specifies the
     * 			index of the axis to which the labels apply. Separate each label by using a pipe character (|).
     * 'chxr' - Specify a range for axis labels with <axis index>,<start of range>,<end of range>,<interval>|
     * 			The <interval> parameter is optional. Separate multiple axis label ranges by using the pipe character (|).
     * 'chxs' - Specify font size, color, and alignment for axis labels with <axis index>,<axis color>,<font size>,<alignment>,<drawing control>,<tick mark color>|
     * 			  <axis index> is the axis index as specified in chxt.
     * 			  <axis color> is an RRGGBB format hexadecimal number.
     * 			  <font size> specifies the font size in pixels. This parameter is optional.
     * 			  <alignment> is one of the following:
     *     			 -1 to make the axis labels left-aligned.
     *    			  0 to make the axis labels centered.
     *      	      1 to make the axis labels right-aligned.
     *				  By default, x--axis labels and t-axis labels are centered, y-axis labels are right-aligned,
     * 				  and r-axis labels are left-aligned. This parameter is optional.
     * 			  <drawing control> is one of the following:
     * 				  'l' to draw axis lines only.
     * 				  't' to draw tick marks only.
     * 				  'lt' to draw axis lines and tick marks.
     * 				   This parameter is optional.
     * 			  <tick mark color> is an RRGGBB format hexadecimal number. This parameter is optional.
     * 			Values for multiple axes should be separated using a pipe character (|).
     * 'chm' - Add labels to data points on line charts, bar charts, radar charts, and scatter plots with:
     * 			<label type><label contents>,<color>,<data set index>,<data point>,<size>,<priority>|
     * 		Where:
     * 		<label type> is one of the following characters:
     *     		 f creates a flag.
     *     		 t creates plain text.
     *     		 N creates a number.
     * 		<label contents> is the text of the label, for f and t labels. Number labels are discussed below.
     * 		<color> is an RRGGBB format hexadecimal number.
     * 		<data set index> is the index of the data set on which to draw the label.
     * 				The data set index is 0 for the first data set, 1 for the second data set, and so on.
     * 		<data point> is a floating point value that specifies the data point on which the label will be drawn.
     * 				Use one of the following formats:
     *     		  0 to draw a label on the first data point, 1 to draw a label on the second data point, and so on.
     *     		 -1 to draw a label on each data point.
     *     		 -n to draw a label on every n-th data point.
     *     		 x:y:n to draw a label on every n-th data point in a range, where x is the first data point in the range,
     * 				and y is the last data point in the range.
     * 		<size> is the size of the text in points.
     * 		<priority> is one of the following:
     *    		-1 specifies that the label is drawn before all other parts of the chart.
     * 				The label will be hidden if another chart element is drawn in the same place.
     *     		 0 specifies that the label is drawn after bars or lines, but before other labels. This is the default.
     *     		 1 specifies that the label is drawn after all other parts of the chart.
     * 				If more than one label has this value, the first one specified in the chm parameter
     * 				will be drawn first, the second one specified in the chm parameter will be drawn second, and so on.
     * 			Multiple labels are separated using the pipe character (|).
     * 'chbh' - For bar charts, specify bar thickness and spacing <bar width>,<space between bars>,<space between groups>
     * 		<bar width> should be specified in pixels. Use a instead of a pixel value to automatically resize bars, as described below.
     * 		Use r instead of a pixel value to resize bars by using relative spacing, as described below.
     * 'chma' - chart margin - <left margin>,<right margin>,<top margin>,<bottom margin>|<legend width>,<legend height>
     *
     *
     * @var array
     */
    protected $options = array(
    'chs' => '250x100' ,
    'chd' => 't:1,2,3,6,4,7,8' ,
    'cht' => 'bvs' ,
    'chtt' => 'Some+title' ,
    'chco' => '709030' ,
    'chf' => 'bg,s,ffffff' ,
    'chxt' => 'x,y' ,
    'chxl' => '0:|Mon|Tue|Wed|Thu|Fri|Sat|Sun|' ,
    'chxr' => '1,0,10' ,
    'chts' => '666666,14' ,
    'chbh' => 'r,0.1,0.4' ,
    'chma' => '20,20,20,20' ,
    'chds' => '0,10');
    protected $host = 'http://chart.apis.google.com';//bgcolor' => , 'titlecolor' => ,
    protected $hostpath = '/chart?';
    protected $title = 'Sample chart';
    protected $width = 250;
    protected $height = 250;
    protected $barcolor = '709030';
    protected $bgcolor = 'D7E4BD';
    protected $titlecolor = '666666';
    protected $data = array(1,2);
    protected $labels = array('one', 'two');
    protected $max = 100;
    protected $min = 0;
    protected $count = 2;
    protected $url;
    protected $cachedir = 'cache';
    protected $cachefile;
    protected $usedcache = false;
    protected $cache = false;
    protected $userAgent = "PHP Script";
    protected $querystring;
    /**
     * Chart type
     *
     * @var string
     */
    protected $chtype;
    protected $chtypes = array(
    'ls' => "line chart" ,
    'ls' => "line spikes" ,
    'lxy' => "line complex" ,
    'bhs' => "bar horizontal staked" ,
    'bvs' => "bar vertical staked" ,
    'bhg' => "bar horizontal grouped" ,
    'bvg' => "bar vert grouped" ,
    'p' => "2d pie chart" ,
    'p3' => "3d piechart" ,
    'pc' => "concentric pie");
    function labels() {
    	$data = $this->labels;
        return '0:|' . implode('|', $data) . '|';
    }

    function buildUrl ()
    {
        $opts = $this->options;
        $opts['chs'] = $this->width . "x" . $this->height;$opts['cht'] = $this->chtype;
        $data = implode(',', $this->data);
        $opts['chd'] = 't:' . $data;
        $opts['chtt'] = $this->title;
        $opts['chco'] = $this->barcolor;
        $opts['chf'] = 'bg,s,' . $this->bgcolor;
        $opts['chts'] = $this->titlecolor . ',14';
        $opts['chxl'] =  $this->labels();
        if ($this->max < 10) {
            $max = 10;
        } elseif ($this->max < 50) {
            $max = 50;
        } elseif ($this->max < 100) {
            $max = 100;
        } else {
            $max = $this->max;
        }
        switch ($this->count) {
            case 90:
                $opts['chbh'] = 'r,0.1,0.3';
                break;
            default:
                $opts['chbh'] = 'a';
                break;
        }
        $opts['chds'] = (int) $this->min . ',' . (int) $max;
        $opts['chxr'] = '1,' . (int) $this->min .
                     ',' .
                     (int) $max;
        $url = $this->host . $this->hostpath;
        $querystring = '';
        foreach ($opts as $key => $value) {
            $pair = $key . '=' . $value;
            $querystring .= $pair .
                         '&';
        }
        $querystring = substr($querystring, 0, - 1);
        $url .= $querystring;
        $this->querystring = $querystring;
        $this->cachefile = 'googlegraph_' . md5($url) .
                     '.png';
        $path = $this->cachedir . DIRECTORY_SEPARATOR .
                     $this->cachefile;
        if (is_file($path) && is_readable($path)) {
            $url = $path;
            $this->usedcache = true;
        }
        $this->url = $url;
        return true;
    }
    function getImageTag ()
    {
        $href = $this->getUrl();
        if ($href) {
            $img = '<img src="' .
                         $this->url .
                         '" alt="' .
                         urldecode($this->title) .
                         '" />';
            return $img;
        }
        return "Image url not ready.";
    }
    protected function saveImage ($name)
    {
        $href = $this->url;
        $host = str_ireplace('http://', '', $this->host);
        $oCurl = curl_init($href);
        curl_setopt($oCurl, CURLOPT_CONNECTTIMEOUT, 3);
        curl_setopt($oCurl, CURLOPT_TIMEOUT, 5);
        curl_setopt($oCurl, CURLOPT_USERAGENT, $this->userAgent);
        curl_setopt($oCurl, CURLOPT_HEADER, false);
        curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($oCurl, CURLOPT_FAILONERROR, true);
        $contents = curl_exec($oCurl);
        //        $contents = @file_get_contents($href);
        $result = $contents;
        $path = $this->cachedir . DIRECTORY_SEPARATOR .
                     $name;
        if ($result) {
            file_put_contents($path, $result);
        }
    }
    function getUrl ()
    {
        if (!$this->url) {
            $this->buildUrl();
        }
        return $this->url;
    }
    function __construct ($data,
                $options = array('width' => 250, 'height' => 250, 'title' => 'Some title', 'barcolor' => '709030', 'bgcolor' => 'D7E4BD', 'titlecolor' => '666666', 'cache' => 'cache', 'cht' => 'bvs'))
    {
        $this->setData($data);
        extract($options);
        if (isset($width) && isset($height)) {
            $this->setDimensions($width, $height);
        }
        if (isset($title)) {
            $this->title = urlencode($title);
        }
        if (isset($barcolor)) {
            $this->setBarcolor($barcolor);
        }
        if (isset($bgcolor)) {
            $this->setBgcolor($bgcolor);
        }
        if (isset($titlecolor)) {
            $this->setTitlecolor($titlecolor);
        }
        if (isset($cache)) {
            $this->cache = $this->setCacheDir($cache);
        }
        if (isset($cht) && array_key_exists($cht, $this->chtypes)) {
            $this->chtype = $cht;
        }
    }
    function setCacheDir ($dir)
    {
        if (is_dir($dir))
            return true;
        if (mkdir($dir))
            return true;
        return false;
    }
    function setBarcolor ($color)
    {
        if (! $this->checkColor($color)) {
            $this->barcolor = "709030";
            return false;
        }
        $this->barcolor = $color;
        return true;
    }
    function setBgcolor ($color)
    {
        if (! $this->checkColor($color)) {
            $this->bgcolor = "D7E4BD";
            return false;
        }
        $this->bgcolor = $color;
        return true;
    }
    function setTitlecolor ($color)
    {
        if (! $this->checkColor($color)) {
            $this->titlecolor = "666666";
            return false;
        }
        $this->titlecolor = $color;
        return true;
    }
    protected function checkColor ($color)
    {
        if (strlen($color) != 6) {
            return false;
        }
        $c1 = substr($color, 0, 2);
        $c2 = substr($color, 2, 2);
        $c3 = substr($color, 4, 2);
        if (hexdec($c1) > 255 || hexdec($c2) > 255 ||
                     hexdec($c3) >
                     255) {
                        return false;
        }
        return true;
    }
    function setDimensions ($width, $height)
    {
        $w = (int) $width;
        $h = (int) $height;
        $this->width = $w + 20;
        $this->height = $h + 20;
    }
    function setData ($data)
    {
        if (! is_array($data)) {
            throw new Exception('Data must be in array form');
        }
        $this->count = count($data);
        $min = 0;
        $max = 0;
        $labels = array();
        $items = array();
        foreach ($data as $key => $item) {
            if (is_numeric($item['value'])) {
                $max = $item['value'] >
                             $max ? $item['value'] : $max;
                $min = $item['value'] <
                             $min ? $item['value'] : $min;
                if (is_string($item['label']) && !is_numeric($item['label'])) {
                                $labels[] = $item['label'];
                } else {
                    $labels[] = '';
                }
                $items[] = $item['value'];
            }
        }
        $this->min = $min;
        $this->max = $max;
        $this->labels = $labels;
        $this->data = $items;
    }
    function graph ($count = 0)
    {
        $count = (int) $count;
        if ($count > $this->count) {
            $this->count = $count;
        }
        if ($this->buildUrl()) {
            if ($this->cache && ! $this->usedcache) {
                $this->saveImage($this->cachefile);
            }
            return $this->getUrl();
        }
        return "We could not generate graphs.";
    }
}
?>